Bug 196916 - Multipath needs to interact with gnbd better
Multipath needs to interact with gnbd better
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: device-mapper-multipath (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ben Marzinski
Depends On:
  Show dependency treegraph
Reported: 2006-06-27 12:52 EDT by Ben Marzinski
Modified: 2010-01-11 21:26 EST (History)
9 users (show)

See Also:
Fixed In Version: RHEA-2007-0256
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-05-01 13:41:18 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
patch for multipath.dev, so that multipath only monitors the correct devices (659 bytes, patch)
2006-08-23 11:37 EDT, Ben Marzinski
no flags Details | Diff

  None (edit)
Description Ben Marzinski 2006-06-27 12:52:51 EDT
There are two issues where multipath doesn't deal with gnbd devices well.

1. If multipathd is started before the gnbd module is loaded, multipathd starts
monitoring all 128 possible gnbd devices.  This get's rather annoying.
Currently, the workaround for this is to either start or restart multipathd
after the gnbd modules are loaded. The other possibility is to add the following

multipathd should never monitor gnbd devices that aren't activated.

2. The default getuid callout for GNBD devices is "/sbin/gnbd_import -U
/block/%n". Unfortunately, with this callout, if there are any warning messages
printed while running the command, they will end up as part of the UID. This
keeps the maps for correctly being set up. The default getuid needs to be
"/sbin/gnbd_import -q -U /block/%n".  As a workaround, people using gnbd can put
the following in the /etc/multipath.conf:

        device {
                vendor                  "GNBD"
                product                 "GNBD"
                path_grouping_policy    multibus
                getuid_callout          "/sbin/gnbd_import -p -U /block/%n"
                path_checker            directio
Comment 1 Ben Marzinski 2006-08-23 11:37:24 EDT
Created attachment 134728 [details]
patch for multipath.dev, so that multipath only monitors the correct devices

This patch fixes the first problem, where multipathd monitors unused gnbd
devices. Even with this patch, it is still necessary to modify the
multipath.conf file as described
Comment 2 Ben Marzinski 2006-08-23 11:38:51 EDT
Added these fixes to the multipath package
Comment 3 Ben Marzinski 2006-08-23 11:46:22 EDT
Just to note, to apply the multipath_gnbd_update.patch from Comment #1

# patch -p0 -d /etc/dev.d/block/ < multipath_gnbd_update.patch
Comment 8 Ben Levenson 2007-04-11 00:01:41 EDT
This fix is in the latest snapshot.  Please retest with the latest packages:
Comment 10 Red Hat Bugzilla 2007-05-01 13:41:18 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.